require "import"
import "android.widget.*"
import "com.androlua.*"

sergio = {
    "start or stop recording",
    "view log",
    "edit the record in an edit box",
    "delete record"
}

layout = {
    GridView,
    id = "grid",
    numColumns = 1,
    layout_width = "fill",
    layout_height = "fill"
}

dlg = LuaDialog(service)
dlg.View = loadlayout(layout)
dlg.setTitle("speech history")
grid.adapter = SingleLineAdapter(service, String(sergio))
dlg.setButton("Cancel", nil)
dlg.show()

grid.onItemClick = function(l, v)
dlg.dismiss()
    if v.text == "edit the record in an edit box" then
        require "import"
        import "android.widget.*"
        import "com.androlua.*"
        import "android.widget.ArrayAdapter"
        import "android.widget.LinearLayout"
        import "android.widget.TextView"
        import "java.io.File"
        import "android.widget.ListView"
        import "android.app.AlertDialog"

        InputLayout = {
            LinearLayout;
            orientation="vertical";
            {
                EditText;
                id="edit";
                layout_width="90%w";
            };
        };

        local filePath = "/storage/emulated/0/speak.txt"
        local file = io.open(filePath, "r")

        if file then
            local contents = file:read("*all")
            file:close()

            dlg = LuaDialog(service)
                .setTitle("file content")
                .setView(loadlayout(InputLayout))
                .setButton("save", {
                    onClick = function(v)
                        local file = io.open(filePath, "w")
                        if file then
                            file:write(edit.getText().toString())
                            file:close()
                            dlg.dismiss()
                        else
                            print("Error: could not save the file")
                        end
                    end
                })
                .show()

            edit.setText(contents)
        else
            print("Error: could not open the file")
        end
    elseif v.text == "delete record" then
        local file = io.open("/storage/emulated/0/speak.txt", "w")
        file:write("")
        file:close()
    elseif v.text == "start or stop recording" then
        require "import"
        import "java.io.*"
        LuaDialog(service)
            .setTitle("speaking log")
            .setMessage("what do you want to do?")
            .setButton("start!", function()
                this.setTextToSpeechListener{
                    function onSpeak(text)
                        local f="/sdcard/speak.txt"
                        local fl="...START..."
                        if File(f).exists() then
                            fl=io.open(f,"rb"):read("*a")
                        end
                        io.open(f,"wb"):write(fl.."\n"..text):close()
                    end
                }
            end)
            .setButton2("stop!", function()
                this.setTextToSpeechListener{
                    function onSpeak(text)
                        return true
                    end
                }
            end)
            .show()
    elseif v.text == "view log" then local os = require "os"
local io = require "io"

function get_file_path(filename)
    local path1 = "/storage/emulated/0" .. filename
    local path2 = "/storage/emulated/0/" .. filename
    if file_exists(path1) then
        return path1
    elseif file_exists(path2) then
        return path2
    else
        return nil
    end
end

function file_exists(path)
    local file = io.open(path, "r")
    if file then
        io.close(file)
        return true
    else
        return false
    end
end

local files = {
    "speak.txt"
}
local lines_per_segment = 1

for _, file in ipairs(files) do
    local path = get_file_path(file)
    if path then
        local f = assert(io.open(path, "r"))
        local content = f:read("*all")
        f:close()

        local lines = {}
        for line in content:gmatch("[^\r\n]+") do
            table.insert(lines, line)
        end

        local num_segments = math.ceil(#lines / lines_per_segment)
        for i = 1, num_segments do
            local start_index = (i - 1) * lines_per_segment + 1
            local end_index = math.min(start_index + lines_per_segment - 1, #lines)
            local segment_lines = {}
            for j = start_index, end_index do
                table.insert(segment_lines, lines[j])
            end
            local segment_content = table.concat(segment_lines, "\n")
            -- hacer lo que quieras con el segmento de texto, por ejemplo:
print("" .. "\n" .. segment_content .. "\n")
        end
        end
end
    end
end